Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.Xml.XPath

Public Class frmXML
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnWriteXML As System.Windows.Forms.Button
    Friend WithEvents btnReadXML As System.Windows.Forms.Button
    Friend WithEvents btnExecuteXML As System.Windows.Forms.Button
    Friend WithEvents grdData As System.Windows.Forms.DataGrid
    Friend WithEvents btnNavigateSQL As System.Windows.Forms.Button
    Friend WithEvents btnAddRows As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnWriteXML = New System.Windows.Forms.Button()
        Me.btnReadXML = New System.Windows.Forms.Button()
        Me.btnExecuteXML = New System.Windows.Forms.Button()
        Me.grdData = New System.Windows.Forms.DataGrid()
        Me.btnNavigateSQL = New System.Windows.Forms.Button()
        Me.btnAddRows = New System.Windows.Forms.Button()
        CType(Me.grdData, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'btnWriteXML
        '
        Me.btnWriteXML.Location = New System.Drawing.Point(16, 80)
        Me.btnWriteXML.Name = "btnWriteXML"
        Me.btnWriteXML.Size = New System.Drawing.Size(120, 32)
        Me.btnWriteXML.TabIndex = 0
        Me.btnWriteXML.Text = "Write XML"
        '
        'btnReadXML
        '
        Me.btnReadXML.Location = New System.Drawing.Point(16, 24)
        Me.btnReadXML.Name = "btnReadXML"
        Me.btnReadXML.Size = New System.Drawing.Size(120, 32)
        Me.btnReadXML.TabIndex = 1
        Me.btnReadXML.Text = "Read XML"
        '
        'btnExecuteXML
        '
        Me.btnExecuteXML.Location = New System.Drawing.Point(16, 136)
        Me.btnExecuteXML.Name = "btnExecuteXML"
        Me.btnExecuteXML.Size = New System.Drawing.Size(120, 32)
        Me.btnExecuteXML.TabIndex = 2
        Me.btnExecuteXML.Text = "ExecuteXMLReader"
        '
        'grdData
        '
        Me.grdData.DataMember = ""
        Me.grdData.HeaderForeColor = System.Drawing.SystemColors.ControlText
        Me.grdData.Location = New System.Drawing.Point(192, 24)
        Me.grdData.Name = "grdData"
        Me.grdData.Size = New System.Drawing.Size(416, 384)
        Me.grdData.TabIndex = 3
        '
        'btnNavigateSQL
        '
        Me.btnNavigateSQL.Location = New System.Drawing.Point(16, 192)
        Me.btnNavigateSQL.Name = "btnNavigateSQL"
        Me.btnNavigateSQL.Size = New System.Drawing.Size(120, 32)
        Me.btnNavigateSQL.TabIndex = 4
        Me.btnNavigateSQL.Text = "Navigate SQL"
        '
        'btnAddRows
        '
        Me.btnAddRows.Location = New System.Drawing.Point(16, 248)
        Me.btnAddRows.Name = "btnAddRows"
        Me.btnAddRows.Size = New System.Drawing.Size(120, 32)
        Me.btnAddRows.TabIndex = 5
        Me.btnAddRows.Text = "Add rows to XML"
        '
        'frmXML
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(632, 437)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnAddRows, Me.btnNavigateSQL, Me.grdData, Me.btnExecuteXML, Me.btnReadXML, Me.btnWriteXML})
        Me.Name = "frmXML"
        Me.Text = "ADO.NET and XML"
        CType(Me.grdData, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub btnReadXML_Click(ByVal sender As System.Object, _
                        ByVal e As System.EventArgs) Handles btnReadXML.Click
        Dim dsPubs As New DataSet()

        ' Read in XML from file
        dsPubs.ReadXml("..\Pubs.xml")

        ' Bind DataSet to Data Grid
        grdData.DataMember = "publishers"
        grdData.DataSource = dsPubs

    End Sub


    Private Sub btnWriteXML_Click(ByVal sender As System.Object, _
                        ByVal e As System.EventArgs) Handles btnWriteXML.Click
        Dim dsSales As New DataSet()
        Dim cn As New SqlConnection _
                    ("data source=localhost;initial catalog=pubs;user id=sa")
        Dim daAuthors As New SqlDataAdapter("select * from sales ", cn)
        Dim daPublishers As New SqlDataAdapter("select * from stores ", cn)

        ' Load Relational data from database
        daAuthors.Fill(dsSales, "Sales")
        daPublishers.Fill(dsSales, "Stores")

        ' Write XML out to file
        dsSales.WriteXml("..\StoreSales.xml")

        ' Write out schema as XSD file
        dsSales.WriteXmlSchema("..\StoreSales.xsd")

        'Make some changes - modify, delete, and insert a new row
        dsSales.Tables("Stores").Rows(0)("stor_id") = 999       ' Modify
        dsSales.Tables("Stores").Rows(1).Delete()               ' Delete
        Dim rr As DataRow = dsSales.Tables("Stores").NewRow()
        rr("stor_name") = "New Store"
        dsSales.Tables("Stores").Rows.Add(rr)                   ' Insert

        ' Create changes-only diffgram 
        Dim ChangedDataSet = dsSales.GetChanges()
        ChangedDataSet.WriteXml("..\Changes.xml", XmlWriteMode.DiffGram)

        ' Write out data as DiffGram
        dsSales.WriteXml("..\DiffGram.xml", XmlWriteMode.DiffGram)

    End Sub



    Private Sub btnExecuteXML_Click(ByVal sender As System.Object, _
                        ByVal e As System.EventArgs) Handles btnExecuteXML.Click
        Dim cn As New SqlConnection _
                        ("data source=localhost;initial catalog=pubs;user id=sa")
        Dim cmd As New SqlCommand _
                        ("select * from stores for xml auto, elements", cn)
        Dim reader As Xml.XmlReader
        Dim str As New System.Text.StringBuilder()

        cn.Open()

        ' Execute SQL Select command, with FOR XML clause
        reader = cmd.ExecuteXmlReader()

        ' Find and retrieve data from element nodes
        While reader.Read()
            Select Case reader.NodeType
                Case Xml.XmlNodeType.Element
                    str.Append("<" & reader.Name & ">")
                Case Xml.XmlNodeType.EndElement
                    str.Append("</" & reader.Name & ">" & ControlChars.CrLf)
                Case Xml.XmlNodeType.Text
                    str.Append(reader.Value)
                Case Else
                    ' ignore in this example
            End Select
        End While

        MsgBox(str.ToString)

        cn.Close()
    End Sub

    Private Sub btnNavigateSQL_Click(ByVal sender As System.Object, _
                    ByVal e As System.EventArgs) Handles btnNavigateSQL.Click
        Dim cn As New SqlConnection _
                    ("data source=localhost;initial catalog=pubs;user id=sa")
        Dim da As New SqlDataAdapter("Select * from authors", cn)
        Dim ds As New DataSet()

        ' Fill DataSet with data from relational database
        da.Fill(ds, "authors")

        ' Create a XmlDataDocument based on the existing DataSet
        Dim xmlDoc As New Xml.XmlDataDocument(ds)

        ' Get an Navigator for the XmlDataDocument			
        Dim xmlNav As XPathNavigator = xmlDoc.CreateNavigator()

        ' Get all the Author last names from California (state = CA)			
        Dim xIterator As XPathNodeIterator
        xIterator = _
         xmlNav.Select("//authors[state='CA']/au_lname")

        ' Iterate over all of the selected nodes and
        ' display the author last Names
        Dim str As New System.Text.StringBuilder()
        While (xIterator.MoveNext())
            str.Append(xIterator.Current.Value & ControlChars.CrLf)
        End While
        MsgBox(str.ToString)

    End Sub

    Private Sub btnAddRows_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddRows.Click
        Dim dsPubs As New DataSet()

        ' Read in XML from file
        dsPubs.ReadXml("..\Pubs.xml")

        ' NOW - add a new row
        Dim row As DataRow = dsPubs.Tables("Publishers").NewRow()
        row("pub_name") = "Newbie Publishing Corp."
        row("city") = "New York"
        row("state") = "NY"
        row("Country") = "USA"
        dsPubs.Tables("Publishers").Rows.Add(row)

        ' Bind DataSet to Data Grid to see new data
        grdData.DataMember = "publishers"
        grdData.DataSource = dsPubs

    End Sub
End Class
